
import os,profile,sys
from tempfile import mkstemp
from stat import *
from sys import argv
from struct import pack,unpack
from collections import deque
from array import array
from bisect import bisect

#import psyco
#psyco.full()

SIZE = 128 * 1024
APACK = 2

# number of hash tables to use - 1
hashlen = 25
# maximum number of entries in a list in the last hash table
hashmax = 500000

def checksum(str):
	sum = 0
	for i in range(128):
		sum += unpack("<I", str[i*128:i*128+4])[0]
	return (sum & 0xffffffff)

# read a whole file
def readfile(name):
	fd = open(name, "rb")
	contents = fd.read()
	fd.close()
	return os.stat(name)[ST_SIZE], contents

# write a whole file
def writefile(name, contents):
	fd = open(name, "wb")
	fd.write(contents)
	fd.close()

def writetemp(contents):
	(fd, name) = mkstemp()
	os.write(fd,contents)
	os.close(fd)
	return name

class apack:
	def compress(self, z):
		'''the actual apack compressor

		   returns compressed string'''
		inname = writetemp(z)
		(tmp, outname) = mkstemp()
		os.close(tmp)
		path = "apack.exe"
		os.spawnl(os.P_WAIT, path, "apack.exe", inname, outname)
		os.remove(inname)
		(size, str) = readfile(outname)
		os.remove(outname)
		return str

def cap(filein, fileout):
	size, contents = readfile(filein)
	cmp = apack().compress(contents)
	chksum = checksum(contents)
	col = "\x11" + pack("<I", chksum)
	col += cmp
	writefile(fileout, col)

if __name__ == "__main__":
	if len(argv) == 3:
		cap(argv[1], argv[2])
